#include "DAGH.h"
#include "Consts.h"
#include "ADMvar.h"
#include "SArray.h"
#include "TArray.h"
#include "BHmask.h"
#include "Variables.h"
#include "fortran.h"
#include "input_params.h"

void  tstep(int t, int Level, double *params, ADMscalar *an, ADMscalar *bn,
      ADMscalar *cn, ADMscalar *dn, ADMscalar *phi,
      ADMscalar *temp, int init, int idt, double Time, int myrank)

{
INTEGER itc;
DOUBLE endtime;
INTEGER cg;
GridFunction(DIM)<DOUBLE> &st = *(*an).spacetime[0];
int *ntmp = (*(*theMask).nl).data();
int *ni   = (*(*shift_p).n).data();
int *nio  = (*(*shift_po).n).data();
int *npi  = (*(*shift_t).n).data();
int nl;
int num_int_points;
int num_int_pointso;
int np;

// subroutine tstep(params, anm_, an_, anp_, bnm_,  
// bn_, bnp_,      cnm_, cn_, cnp_, dnm_, dn_, dnp_,  
// phim_, phi, phip_, temp)
//   implicit none
//   INTERFACE
//      subroutine leapfrogA(params, anm,an,anp, bn,cn,dn)
//        implicit none
//      end subroutine leapfrogA
//      subroutine leapfrogBCD(params, an, bnm, bn,  
// bnp, cnm, cn, cnp,          dnm, dn, dnp)
//        implicit none
//      end subroutine leapfrogBCD
//      subroutine updatephi(params, an, phip, phim)
//        implicit none
//      end subroutine updatephi
//      subroutine boundupdt(params, an, anp, bn, bnp,  
// cn, cnp, dn, dnp, phip)
//        implicit none
//      end subroutine boundupdt
//      subroutine dump_2d(params, name, u)
//        implicit none
//        character*(*) name
//      end subroutine dump_2d
//      subroutine swaptime(anm,an,anp, bnm,bn,bnp,  
//          cnm,cn,cnp, dnm,dn,dnp, phim,phi,phip)
//        implicit none
//      end subroutine swaptime
//   END INTERFACE
if(myrank==0) cout<<  ". " << " " 
<< endl;
     forall(st,t,Level,cg){
       f_leapfroga(FBA(st(t,Level,cg,DAGH_Main)),
       params,
       (*(*an).spacetime[0])(t-idt,Level,cg,DAGH_Main).data(),
       (*(*an).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*an).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*bn).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*cn).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*dn).spacetime[0])(t,Level,cg,DAGH_Main).data());
     } end_forall;


     forall(st,t,Level,cg){
       f_leapfrogbcd(FBA(st(t,Level,cg,DAGH_Main)),
       params,
       (*(*an).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*bn).spacetime[0])(t-idt,Level,cg,DAGH_Main).data(),
       (*(*bn).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*bn).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*cn).spacetime[0])(t-idt,Level,cg,DAGH_Main).data(),
       (*(*cn).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*cn).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*dn).spacetime[0])(t-idt,Level,cg,DAGH_Main).data(),
       (*(*dn).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*dn).spacetime[0])(t+idt,Level,cg,DAGH_Main).data());
     } end_forall;


     forall(st,t,Level,cg){
       f_updatephi(FBA(st(t,Level,cg,DAGH_Main)),
       params,
       (*(*an).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*phi).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*phi).spacetime[0])(t-idt,Level,cg,DAGH_Main).data());
     } end_forall;


     forall(st,t,Level,cg){
       f_swaptime(FBA(st(t,Level,cg,DAGH_Main)),
       (*(*an).spacetime[0])(t-idt,Level,cg,DAGH_Main).data(),
       (*(*an).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*an).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*bn).spacetime[0])(t-idt,Level,cg,DAGH_Main).data(),
       (*(*bn).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*bn).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*cn).spacetime[0])(t-idt,Level,cg,DAGH_Main).data(),
       (*(*cn).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*cn).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*dn).spacetime[0])(t-idt,Level,cg,DAGH_Main).data(),
       (*(*dn).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*dn).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*phi).spacetime[0])(t-idt,Level,cg,DAGH_Main).data(),
       (*(*phi).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*phi).spacetime[0])(t+idt,Level,cg,DAGH_Main).data());
     } end_forall;


//   return  
// end subroutine tstep

}
